using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Phoenix;
using Phoenix.WorldData;
using Phoenix.Communication;

namespace Scripts.DarkParadise
{
    public class AllNames
    {
        private UOColor[] notorietyColors = new UOColor[] { Env.DefaultConsoleColor, 0x0063, 0x0044, 0x03E9, 0x03E5, 0x0030, 0x0026, 0x0481 };

        public static bool ShowNames = false;

        public AllNames()
        {
            World.CharacterAppeared += new CharacterAppearedEventHandler(World_CharacterAppeared);
        }

        void World_CharacterAppeared(object sender, CharacterAppearedEventArgs e)
        {
            if (!ShowNames)
                return;

            UOCharacter mob = new UOCharacter(e.Serial);

            if (mob.Name != null) {
                PrintName(mob);
            }
            else {
                mob.Click();
            }
        }
        [Command("allnames")]
        [BlockMultipleExecutions]
        public void Show()
        {
            Show(false);
        }

        [Command("allnames")]
        [BlockMultipleExecutions]
        public void Show(bool enemiesOnly)
        {
            int pause = 50;

            foreach (var mob in World.Characters) {
                if (mob.Serial == World.Player.Serial)
                    continue;
                if (mob.Distance > 18)
                    continue;
                if (enemiesOnly && mob.Notoriety != Notoriety.Murderer)
                    continue;

                if (mob.Name != null) {
                    PrintName(mob);
                }
                else {
                    mob.Click();
                    UO.Wait(pause);
                    pause += 25;
                }
            }

            if (enemiesOnly)
                return;

            foreach (var item in World.Ground) {
                if (item.Graphic != 0x2006 || item.Distance > 18)
                    continue;

                item.Click();
                UO.Wait(pause);
                pause += 25;
            }
        }

        private void PrintName(UOCharacter mob)
        {
            UOColor color = notorietyColors[(int)mob.Notoriety];

            byte[] data = PacketBuilder.CharacterSpeechAscii(mob.Serial, mob.Model, mob.Name, SpeechType.Label, SpeechFont.Normal, color, mob.Name + "*");
            Core.SendToClient(data, true);
        }
    }
}
