﻿using System;
using System.Windows.Forms;
using Phoenix;

namespace Scripts.DarkParadise
{
    [SettingsCategory("Corpses")]
    public partial class CorpsesAutopenSettings : UserControl
    {
        public CorpsesAutopenSettings()
        {
            InitializeComponent();

            CorpsesAutoopen.PropertyChanged += new EventHandler(CorpsesAutoopen_PropertyChanged);
            Disposed += new EventHandler(CorpsesAutopenSettings_Disposed);

            showNames.Checked = CorpsesAutoopen.ShowNames;
            autoOpen.Checked = CorpsesAutoopen.AutoOpen;
        }

        void CorpsesAutopenSettings_Disposed(object sender, EventArgs e)
        {
            CorpsesAutoopen.PropertyChanged -= new EventHandler(CorpsesAutoopen_PropertyChanged);
        }

        void CorpsesAutoopen_PropertyChanged(object sender, EventArgs e)
        {
            if (InvokeRequired) {
                BeginInvoke(new EventHandler(CorpsesAutoopen_PropertyChanged), sender, e);
                return;
            }

            showNames.Checked = CorpsesAutoopen.ShowNames;
            autoOpen.Checked = CorpsesAutoopen.AutoOpen;
        }

        private void showNames_CheckedChanged(object sender, EventArgs e)
        {
            CorpsesAutoopen.ShowNames = showNames.Checked;
        }

        private void autoOpen_CheckedChanged(object sender, EventArgs e)
        {
            CorpsesAutoopen.AutoOpen = autoOpen.Checked;
        }
    }
}
