﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Phoenix;
using System.Threading;
using System.Windows.Forms;
using Phoenix.Gui.Controls;
using Phoenix.Gui;
using Phoenix.Runtime;
using System.Reflection;
using System.Security.Permissions;
using Phoenix.WorldData;
using System.Runtime.InteropServices;
using System.Security;

namespace Scripts.Status
{
    public class StatusBar
    {
        /// <summary>
        /// Zapina/vypina pruhlednost zalozek.
        /// </summary>
        public const bool Transparent = true;

        private bool StatusExists(Serial id)
        {
            return WindowManager.GetDefaultManager().OwnedWindows.OfType<StatusForm>().Where(f => f.MobileId == id).Count() > 0;
        }

        [Executable("statusbar")]
        public void Show()
        {
            UO.Print("Select");
            Show(UIManager.TargetObject());
        }

        [Executable("statusbar")]
        public void Show(Serial id)
        {
            if (!id.IsValid)
                throw new ScriptErrorException("Invalid id.");

            // Kontrola, jestli tahle zalozka uz neexistuje
            if (StatusExists(id)) {
                UO.Print("StatusBar already exists.", "Scripts");
                return;
            }

            // Vytvor okno
            WindowManager.GetDefaultManager().CreateWindow(delegate()
            {
                var f = new StatusForm(id);
                f.Transparency = Transparent;

                return f;
            });
        }

        [Executable("statusall")]
        public void ShowAll()
        {
            foreach (var mob in World.Characters) {
                if (mob.Renamable || mob.Distance > 20)
                    continue;
                if (mob.Notoriety != Notoriety.Innocent && mob.Notoriety != Notoriety.Guild && mob.Notoriety != Notoriety.Criminal)
                    continue;

                // Tohle sice neni thread-safe, ale pravdepodobnost problemu je velmi mala
                if (!StatusExists(mob.Serial)) {
                    UO.Exec("statusbar", mob.Serial);
                    UO.Wait(100);
                }
            }
        }

        /*
        [ClientMessageHandler(0x05)]
        public CallbackResult OnAttack(byte[] data, CallbackResult prevResult)
        {
            uint id = ByteConverter.BigEndian.ToUInt32(data, 1);
            UOCharacter mob = new UOCharacter(id);

            if (mob.Distance < 20 && !StatusExists(mob.Serial)) {
                UO.Exec("statusbar", mob.Serial);
            }

            return CallbackResult.Normal;
        }
        */
    }
}
